// DSS3M.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "DSS3M.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "DSS3MDoc.h"
#include "DSS3MView.h"

#include "DirectSound.inl"
#include "Mixer.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDSS3MApp

BEGIN_MESSAGE_MAP(CDSS3MApp, CWinApp)
	//{{AFX_MSG_MAP(CDSS3MApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSS3MApp construction

CDSS3MApp::CDSS3MApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDSS3MApp object

CDSS3MApp theApp;
CRITICAL_SECTION CriticalSection;

/////////////////////////////////////////////////////////////////////////////
// CDSS3MApp initialization

BOOL CDSS3MApp::InitInstance()
{
  OleInitialize(NULL);                                      // drag & drop

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(10);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_DSS3MTYPE,
		RUNTIME_CLASS(CDSS3MDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CDSS3MView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

  //
  InitializeCriticalSection(&CriticalSection);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

  //
  if(pMainFrame->hrPlay()) AfxMessageBox("ERROR in DSOUND init");

  POSITION pos = pDocTemplate->GetFirstDocPosition();
  if(pos)
    {                                                       // document opened by command line
    CDSS3MDoc   * pDoc     = (CDSS3MDoc   *)pDocTemplate->GetNextDoc(pos);
    CDirectSound* lpDSound = (CDirectSound*)pMainFrame  ->m_lpDSound;
    if(pDoc && pDoc->m_lpMixer && lpDSound)
      {
      pDoc->m_lpMixer->hrStartPlaying(0,0,lpDSound->dwGetFreq(),lpDSound->boGetStereo(),lpDSound->boGet16Bits(),true);
      }
    }

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDSS3MApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CDSS3MApp commands

int CDSS3MApp::ExitInstance() 
  {
  DeleteCriticalSection(&CriticalSection);

  OleUninitialize();                                        // drag & drop
	return CWinApp::ExitInstance();
  }

//
//

void CDSS3MApp::OnFileNew() 
  {
  }

//

void CDSS3MApp::OnUpdateFileNew(CCmdUI* pCmdUI) 
  {
  pCmdUI->Enable(false);
  }

//

void CDSS3MApp::OnFileOpen() 
  {
  char szBuffer[_MAX_PATH];                                 // get the current working directory
  _getcwd(szBuffer,_MAX_PATH);
   
  // open file dialog

	CFileDialog cfileD(TRUE,NULL,NULL,0,
                     "IT/MOD/S3M Files (*.IT,*.MOD,*.S3M)|*.IT;*.MOD;*.S3M|S3M Files (*.S3M)|*.S3M|MOD Files (*.MOD)|*.MOD|IT Files (*.IT)|*.IT||");
  cfileD.m_ofn.lpstrInitialDir = szBuffer;                  // initial dir
#ifdef _DEBUG
  cfileD.m_ofn.lpstrInitialDir = "c:\\zic\\chmind";
#endif
  if(cfileD.DoModal() != IDOK) return;                      // cancel
  CString cstrFName = cfileD.GetPathName();
  _DWND_("open file: " << LPCTSTR(cstrFName));

  // open document

  OpenDocumentFile(LPCTSTR(cstrFName));
  }

//
//

CDocument* CDSS3MApp::OpenDocumentFile(LPCTSTR lpszFileName) 
  {
	return CWinApp::OpenDocumentFile(lpszFileName);
  }
