// DSS3MDoc.cpp : implementation of the CDSS3MDoc class
//

#include "stdafx.h"
#include "DSS3MDoc.h"

#include "Mixer.inl"
#include "Mod.h"
#include "S3M.h"
#include "IT.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//

extern CRITICAL_SECTION CriticalSection;

/////////////////////////////////////////////////////////////////////////////
// CDSS3MDoc

IMPLEMENT_DYNCREATE(CDSS3MDoc, CDocument)

BEGIN_MESSAGE_MAP(CDSS3MDoc, CDocument)
	//{{AFX_MSG_MAP(CDSS3MDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSS3MDoc construction/destruction

CDSS3MDoc::CDSS3MDoc()
  {
  m_lpS3M   = NULL;
  m_lpMixer = NULL;
  }


CDSS3MDoc::~CDSS3MDoc()
  {
  EnterCriticalSection(&CriticalSection);
  delete m_lpS3M;
  delete m_lpMixer;
  m_lpS3M   = NULL;
  m_lpMixer = NULL;
  LeaveCriticalSection(&CriticalSection);
  }


BOOL CDSS3MDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDSS3MDoc serialization

void CDSS3MDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDSS3MDoc diagnostics

#ifdef _DEBUG
void CDSS3MDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDSS3MDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDSS3MDoc commands

BOOL CDSS3MDoc::OnOpenDocument(LPCTSTR lpszPathName) 
  {
//	if (!CDocument::OnOpenDocument(lpszPathName))
//		return FALSE;
//	
//	// TODO: Add your specialized creation code here
//	
//	return TRUE;

  _DWND_("load file: " << lpszPathName);

  // load & init S3M

  char szDrive[_MAX_DRIVE];
  char szDir  [_MAX_DIR];
  char szName [_MAX_FNAME];
  char szExt  [_MAX_EXT];
  _splitpath(lpszPathName,szDrive,szDir,szName,szExt);

  if(!stricmp(szExt,".MOD")) m_lpS3M = new CMOD;
  if(!stricmp(szExt,".S3M")) m_lpS3M = new CS3M;
  if(!stricmp(szExt,".IT" )) m_lpS3M = new CIT;

  m_lpMixer = new CMixer;
  if(!m_lpS3M || !m_lpMixer) return false;

  bool boOK = false;
  if(!m_lpS3M->hrLoad(lpszPathName))
    {
    if(!m_lpS3M->hrCheckSignature())
      {
      if(!m_lpS3M->hrInitVars())
        {
        boOK = true;
        }
      }
    }

  if(!boOK) return false;

  // mixer

  m_lpMixer->vSetSong(m_lpS3M);
  return true;
  }
