// DSS3MView.cpp : implementation of the CDSS3MView class
//

#include "stdafx.h"
#include "DSS3M.h"

#include "DSS3MDoc.h"
#include "DSS3MView.h"

#include "ChildFrm.h"
#include "MainFrm.h"
#include "SoundTrack.inl"
#include "Mixer.inl"
#include "DirectSound.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//

DWORD  CDSS3MView::m_dwNbView = 0;                          // static - nb views created

extern CSoundTrack* lpS3M;
extern CMixer     * lpMixer;
extern CDSS3MView * lpView;

extern CRITICAL_SECTION CriticalSection;

/////////////////////////////////////////////////////////////////////////////
// CDSS3MView

IMPLEMENT_DYNCREATE(CDSS3MView, CFormView)

BEGIN_MESSAGE_MAP(CDSS3MView, CFormView)
	//{{AFX_MSG_MAP(CDSS3MView)
  ON_MESSAGE(WM_UPDATE_CTRLS, OnUpdateCtrls)
	ON_BN_CLICKED(IDC_SONG_RESTART, OnSongRestart)
	ON_BN_CLICKED(IDC_SONG_PAUSE, OnSongPause)
	ON_NOTIFY(UDN_DELTAPOS, IDC_VOLUMESPIN, OnDeltaposVolumespin)
	ON_BN_CLICKED(IDC_SONG_SOUND, OnSongSound)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSS3MView construction/destruction

CDSS3MView::CDSS3MView()
	: CFormView(CDSS3MView::IDD)
  {
	//{{AFX_DATA_INIT(CDSS3MView)
	m_strSongTitre = _T("");
	m_strSongSize = _T("");
	m_strSongChannels = _T("");
	m_strSongStereo = _T("");
	m_strSongVolume = _T("");
	m_strSongOrder = _T("");
	m_strSongRow = _T("");
	m_strSongSpeed = _T("");
	m_strSongSynchro = _T("");
	m_strSongTempo = _T("");
	m_strSongOrderTot = _T("");
	m_strSongTime = _T("");
	//}}AFX_DATA_INIT

  if(!m_dwNbView)
    {/*
    CMainFrame* lpMain = (CMainFrame*)AfxGetMainWnd();
    if(lpMain->hrPlay())                                    // 1st view => init DSound
      AfxMessageBox("ERROR in DSOUND init");*/
    CMainFrame* lpMain = (CMainFrame*)AfxGetMainWnd();
    lpMain->hrPlayDSound();
    }

  m_dwNbView++;
  }


CDSS3MView::~CDSS3MView()
  {
  EnterCriticalSection(&CriticalSection);
  if(this == lpView)
    {
    lpView = NULL;                                          // prevent the timer from playing
    }
  LeaveCriticalSection(&CriticalSection);

  //

  m_dwNbView--;

  if(!m_dwNbView)
    {/*
    CMainFrame* lpMain = (CMainFrame*)AfxGetMainWnd();
    lpMain->hrStop();                                       // last view => release DSound*/
    CMainFrame* lpMain = (CMainFrame*)AfxGetMainWnd();
    lpMain->hrStopDSound();
    }
  }


void CDSS3MView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSS3MView)
	DDX_Control(pDX, IDC_ORDER_SLIDER, m_sliOrder);
	DDX_Control(pDX, IDC_VOLUMESPIN, m_spinVolume);
	DDX_Control(pDX, IDC_SONG_PAUSE, m_btnPause);
	DDX_Text(pDX, IDC_SONG_TITRE, m_strSongTitre);
	DDX_Text(pDX, IDC_SONG_SIZE, m_strSongSize);
	DDX_Text(pDX, IDC_SONG_NBCHANNELS, m_strSongChannels);
	DDX_Text(pDX, IDC_SONG_STEREO, m_strSongStereo);
	DDX_Text(pDX, IDC_SONG_VOLUME, m_strSongVolume);
	DDX_Text(pDX, IDC_SONG_ORDER, m_strSongOrder);
	DDX_Text(pDX, IDC_SONG_ROW, m_strSongRow);
	DDX_Text(pDX, IDC_SONG_SPEED, m_strSongSpeed);
	DDX_Text(pDX, IDC_SONG_SYNCHRO, m_strSongSynchro);
	DDX_Text(pDX, IDC_SONG_TEMPO, m_strSongTempo);
	DDX_Text(pDX, IDC_SONG_ORDERTOT, m_strSongOrderTot);
	DDX_Text(pDX, IDC_SONG_TIME, m_strSongTime);
	//}}AFX_DATA_MAP
}

BOOL CDSS3MView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDSS3MView diagnostics

#ifdef _DEBUG
void CDSS3MView::AssertValid() const
{
	CFormView::AssertValid();
}

void CDSS3MView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDSS3MDoc* CDSS3MView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDSS3MDoc)));
	return (CDSS3MDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDSS3MView message handlers

void CDSS3MView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
  {
  CDSS3MDoc  * pDoc = GetDocument();
  CSoundTrack* pS3M = pDoc->m_lpS3M;
  if(!pS3M) return;
  if( pS3M->hrSetCurParams(0)) return;

  m_strSongTitre    =           pS3M->lpszGetTitle ();
  m_strSongSize    .Format("%u",pS3M->dwGetFileSize());
  m_strSongChannels.Format("%u",pS3M->dwGetChannels());
  m_strSongStereo  .Format("%s",pS3M->boGetStereo  () ? "ON" : "OFF");
  m_strSongOrderTot.Format("%u",pS3M->bGetNbOrders ());

  m_sliOrder.SetRange(1,pS3M->bGetNbOrders(),true);
  m_sliOrder.SetPos  (  pS3M->bGetOrder());

  m_listChannels.SubclassDlgItem(IDC_SONG_CHANNELS,this);
  m_listChannels.ResetContent();
  DWORD dwChannels = pS3M->dwGetChannels();
  char  szBuf[256];

  for(DWORD dwChan = 0; dwChan < dwChannels; dwChan++)
    {
    sprintf(szBuf,"Channel %2d",dwChan);
    DWORD dwIndex = m_listChannels.AddString(szBuf);
    m_listChannels.SetItemData(dwIndex,0);
    m_listChannels.SetCheck   (dwIndex,pS3M->boIsChanActive((BYTE)dwChan));
    }
  m_listChannels.SetTopIndex(0);

  m_btnPause.SetButtonStyle(BS_CHECKBOX);
  m_btnPause.SetCheck(false);

  m_spinVolume.SetRange(0,64);
  m_spinVolume.SetPos  (pS3M->bGetGlobalVolume());

  UpdateData(false);
  OnUpdateCtrls(0,0);

  CMainFrame  * lpMain   = (CMainFrame  *)AfxGetMainWnd();
  CDirectSound* lpDSound = (CDirectSound*)lpMain->m_lpDSound;

  if(lpDSound) pDoc->m_lpMixer->hrStartPlaying(0,0,lpDSound->dwGetFreq(),lpDSound->boGetStereo(),lpDSound->boGet16Bits(),true);

  EnterCriticalSection(&CriticalSection);
  lpView     = this;
  lpS3M      = pDoc->m_lpS3M;
  lpMixer    = pDoc->m_lpMixer;
  LeaveCriticalSection(&CriticalSection);
  }

//
//

void CDSS3MView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
  {
  EnterCriticalSection(&CriticalSection);

  if(bActivate)
    {
    CDSS3MDoc* pDoc = GetDocument();
    lpView   = this;
    lpS3M    = pDoc->m_lpS3M;
    lpMixer  = pDoc->m_lpMixer;
    }

  LeaveCriticalSection(&CriticalSection);
	CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
  }

//
//

LONG CDSS3MView::OnUpdateCtrls(UINT wParam,LONG lParam) 
  {
  CDSS3MDoc  * pDoc = GetDocument();
  CSoundTrack* pS3M = pDoc->m_lpS3M;
  if(!pS3M) return(TRUE);
  if( pS3M->hrSetCurParams(0)) return(TRUE);

  m_strSongVolume  .Format("%u",pS3M->bGetGlobalVolume());
  m_strSongOrder   .Format("%u",pS3M->bGetOrder());
  m_strSongRow     .Format("%u",pS3M->bGetRow());
  m_strSongSpeed   .Format("%u",pS3M->bGetSpeed());
  m_strSongSynchro .Format("%u",pS3M->bGetSynchro());
  m_strSongTempo   .Format("%u",pS3M->bGetTempo());
  m_sliOrder       .SetPos(     pS3M->bGetOrder());

  static DWORD dwOldRunning = (DWORD)-1;
  DWORD dwRunning = (DWORD)pS3M->fGetRunningTime();
  if(dwRunning != dwOldRunning)
    {
    dwOldRunning    =  dwRunning;
    DWORD dwHours   =  dwRunning/3600;
    DWORD dwMinutes = (dwRunning%3600)/60;
    DWORD dwSeconds =  dwRunning%60;
    m_strSongTime.Format("%s%u :%s%u :%s%u",dwHours   < 10 ? "0" : "",dwHours,
                                            dwMinutes < 10 ? "0" : "",dwMinutes,
                                            dwSeconds < 10 ? "0" : "",dwSeconds);
    }

  DWORD dwChannels = pS3M->dwGetChannels();
  for(DWORD dwChan = 0; dwChan < dwChannels; dwChan++)
    {
    pS3M->vSetChanActive((BYTE)dwChan,m_listChannels.GetCheck(dwChan) != 0);
    }

  m_spinVolume.SetPos(pS3M->bGetGlobalVolume());

  UpdateData(false);
  return(TRUE);
  }

//
//

void CDSS3MView::OnSongRestart() 
  {
  CDSS3MDoc  * pDoc = GetDocument();
  CSoundTrack* pS3M = pDoc->m_lpS3M;
  CMixer     * pMix = pDoc->m_lpMixer;
  if(!pS3M) return;
  if(!pMix) return;
  if( pS3M->hrSetCurParams(0)) return;
  if( pMix->hrSetCurParams(0)) return;

  CMainFrame  * lpMain   = (CMainFrame  *)AfxGetMainWnd();
  CDirectSound* lpDSound = (CDirectSound*)lpMain->m_lpDSound;

  if(lpDSound) pMix->hrStartPlaying(0,0,lpDSound->dwGetFreq(),lpDSound->boGetStereo(),lpDSound->boGet16Bits(),true);
  m_btnPause.SetCheck(false);
  }

//
//

void CDSS3MView::OnSongPause() 
  {
  CDSS3MDoc* pDoc   = GetDocument();
  CMixer   * pMixer = pDoc->m_lpMixer;
  if(!pMixer) return;
  if( pMixer->hrSetCurParams(0)) return;

  bool boState = (m_btnPause.GetCheck() != 0);
  m_btnPause.SetCheck(!boState);
  pMixer->vSetPlay   ( boState);
  }

//
//

void CDSS3MView::OnDeltaposVolumespin(NMHDR* pNMHDR, LRESULT* pResult) 
  {
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	*pResult = 0;

  CDSS3MDoc  * pDoc = GetDocument();
  CSoundTrack* pS3M = pDoc->m_lpS3M;
  if(!pS3M) return;
  if( pS3M->hrSetCurParams(0)) return;

  int iNew = pNMUpDown->iPos+pNMUpDown->iDelta;
  if(iNew <  0) iNew = 0;
  if(iNew > 64) iNew = 64;
  pS3M->vSetGlobalVolume(BYTE(iNew));
  }

//

void CDSS3MView::OnSongSound() 
  {
  static BYTE bOrdRow[13][2] = { {37,0}, {37,32}, {37,48}, {37,56},
                                 {38,0}, {38,4},  {38,12}, {38,20}, {38,32}, {38,50},
                                 {39,0}, {39,8},  {39,20} };
  int iRand = rand() % 13;

  CMainFrame  * lpMain   = (CMainFrame  *)AfxGetMainWnd();
  CDirectSound* lpDSound = (CDirectSound*)lpMain->m_lpDSound;
  DWORD         dwSndHandle;

  if(lpDSound && lpMixer)
    {
    if(!lpMixer->hrStartPlaying(bOrdRow[iRand][0],bOrdRow[iRand][1],lpDSound->dwGetFreq(),lpDSound->boGetStereo(),lpDSound->boGet16Bits(),
                                false,true,&dwSndHandle))
      {
      lpMixer->hrSetPanning(dwSndHandle, rand() & 15);
      lpMixer->hrSetVolume (dwSndHandle,(rand() & 31)+32);
      }
    }
  }

//

void CDSS3MView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  if(pScrollBar == (CScrollBar*)&m_sliOrder)
    {                                                       // slider order
    CDSS3MDoc  * pDoc = GetDocument();
    CSoundTrack* pS3M = pDoc->m_lpS3M;
    if(pS3M && !pS3M->hrSetCurParams(0))
      {
      BYTE bOrder    = pS3M->bGetOrder();
      BYTE bNbOrders = pS3M->bGetNbOrders();

      switch(nSBCode)
        {
        case SB_THUMBPOSITION :
        case SB_THUMBTRACK    : bOrder = nPos;
                                if(!bOrder) bOrder++;
                                break;
        case SB_LINERIGHT     : bOrder++;            
                                break;
        case SB_LINELEFT      : if(bOrder >  1) bOrder--; 
                                break;
        case SB_PAGELEFT      : if(bOrder > 10) bOrder -= 10;
                                else bOrder = 1;     
                                break;
        case SB_PAGERIGHT     : bOrder += 10;                                
                                if(bOrder >= bNbOrders) bOrder = bNbOrders-1;
                                break;
        default               : bOrder = 255;        
                                break;
        }

      if(bOrder != 255)
        {
        pS3M->boSetOrder (bOrder);
        m_sliOrder.SetPos(bOrder);
        }
      }
    }
	
	CFormView::OnHScroll(nSBCode, nPos, pScrollBar);
  }
