/**********************************************************************************************************************/
/*                                                DIRECTSOUND CLASS                                                   */
/* 03/10/99, M : creation of the file                                                                                 */
/*               provides access to DirectSound primary or secondary buffer, to play                                  */
/* 10/06/00, M : errors                                                                                               */
/**********************************************************************************************************************/

#if !defined(AFX_DSOUND_H__4C0D8F3D_79A8_11D3_9848_FD35403E9742__INCLUDED_)
#define AFX_DSOUND_H__4C0D8F3D_79A8_11D3_9848_FD35403E9742__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

#include  <dsound.h>

/************************************************ DEFINE **************************************************************/

/************************************************ TYPEDEF & STRUCT ****************************************************/

/************************************************ CLASSES *************************************************************/

/**********************************************************************************************************************/
/*                                                DSound                                                              */
/**********************************************************************************************************************/

class     CDirectSound
  {
// public methods

  public:

    // constructors & destructor

	  CDirectSound                        (void);
	 ~CDirectSound                        (void);

    void            vInit               (void);
    void            vClean              (void);

    // inits

    HRESULT         hrCreateObject      (void);
    HRESULT         hrSetCooperative    (const HWND hWnd,const DWORD dwLevel);
    HRESULT         hrSetBestCoopLevel  (const HWND hWnd);
    HRESULT         hrIsPrimaryHardware (bool* lpboResult);
    void            vChooseFormat       (const DWORD dwFreq,const bool bo16Bits,const bool boStereo);
    HRESULT         hrCreatePrimary     (void);
    HRESULT         hrSetFormat         (void);
    HRESULT         hrGetSize           (DWORD* lpdwSize);
    HRESULT         hrClearBuffer       (void);

    // play

    HRESULT         hrPlay              (void);
    HRESULT         hrStop              (void);

    // get

    LPDIRECTSOUNDBUFFER lpdsbGetBuffer  (void) const;
    DWORD           dwGetBytesPerSample (void) const;
    DWORD           dwGetBytesPerSec    (void) const;
    DWORD           dwGetFreq           (void) const;
    bool            boGetStereo         (void) const;
    bool            boGet16Bits         (void) const;
    bool            boGetSecondaryFlag  (void) const;
    DWORD           dwGetSecondaryKo    (void) const;

    // set

    void            vSetSecondaryKo     (const DWORD dwKo);
    void            vSetSecondaryFlag   (const bool  boFlag);

// protected members

  protected:

    LPDIRECTSOUND   m_lpdsDSound;
    LPDIRECTSOUNDBUFFER m_lpdsbPrimary;
    bool            m_boSecondary;
    DWORD           m_dwSecondKo;                           // secondary size in Ko

    bool            m_boStereo;
    bool            m_bo16Bits;
    DWORD           m_dwFreq;
    DWORD           m_dwBytesPerSample;
    DWORD           m_dwBufferSize;
  };

/************************************************ INLINE **************************************************************/

//#include  "DirectSound.inl"

/**********************************************************************************************************************/

#endif // !defined(AFX_DSOUND_H__4C0D8F3D_79A8_11D3_9848_FD35403E9742__INCLUDED_)
