/**********************************************************************************************************************/
/*                                                DIRECTSOUND CLASS                                                   */
/* 03/10/99, M : creation of the file                                                                                 */
/*               provides access to DirectSound primary or secondary buffer, to play                                  */
/**********************************************************************************************************************/

#ifndef   _DIRECTSOUND_INL_
#define   _DIRECTSOUND_INL_

/************************************************ INCLUDE *************************************************************/

#include  "DirectSound.h"

/**********************************************************************************************************************/
/*                                                GET                                                                 */
/**********************************************************************************************************************/

inline LPDIRECTSOUNDBUFFER CDirectSound::lpdsbGetBuffer() const
  { 
  return(m_lpdsbPrimary); 
  }

inline DWORD CDirectSound::dwGetBytesPerSample() const
  { 
  return(m_dwBytesPerSample); 
  }

inline DWORD CDirectSound::dwGetBytesPerSec() const
  { 
  return(m_dwFreq*m_dwBytesPerSample); 
  }

inline DWORD CDirectSound::dwGetFreq() const
  { 
  return(m_dwFreq); 
  }

inline bool CDirectSound::boGetStereo() const
  { 
  return(m_boStereo); 
  }

inline bool CDirectSound::boGet16Bits() const
  { 
  return(m_bo16Bits); 
  }

inline bool CDirectSound::boGetSecondaryFlag() const
  { 
  return(m_boSecondary); 
  }

inline DWORD CDirectSound::dwGetSecondaryKo() const
  { 
  return(m_dwSecondKo); 
  }

/**********************************************************************************************************************/
/*                                                GET                                                                 */
/**********************************************************************************************************************/

inline void CDirectSound::vSetSecondaryKo(const DWORD dwKo)
  {
  m_dwSecondKo = dwKo;
  }

inline void CDirectSound::vSetSecondaryFlag(const bool boFlag)
  {
  m_boSecondary = boFlag;
  }

/**********************************************************************************************************************/

#endif
