/**********************************************************************************************************************/
/*                                                IT sample CLASS                                                     */
/* 27/12/99, M : creation of the file                                                                                 */
/*               handles an IT sample                                                                                 */
/**********************************************************************************************************************/

#if !defined(AFX_ITSAMPLE_H__2EE19C60_BC66_11D3_9848_D0068C1C3643__INCLUDED_)
#define AFX_ITSAMPLE_H__2EE19C60_BC66_11D3_9848_D0068C1C3643__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

#include  "Sample.h"                                        // base class

/************************************************ DEFINE **************************************************************/

#define   _ITSMPFLAG_WAVE_              1                   // sample associated with header
#define   _ITSMPFLAG_16BITS_            2                   // 16b/8b sample
#define   _ITSMPFLAG_STEREO_            4                   // stereo/mono sample
#define   _ITSMPFLAG_LOOP_              16                  // use loop
#define   _ITSMPFLAG_SUSLOOP_           32                  // use sustain loop
#define   _ITSMPFLAG_PINGPONG_          64                  // ping pong loop
#define   _ITSMPFLAG_SUSPINGPONG_       128                 // ping pong sustain loop

/************************************************ TYPEDEF & STRUCT ****************************************************/

// IT sample header

#pragma   pack(1)

typedef   struct    {
          char      szIMPS   [ 4];                          // "IMPS" signature
          char      szDOSName[13];                          // DOS  filename (ASCIIZ)
          BYTE      bGlobVol;                               // global volume [0;64]
          BYTE      bFlags;                                 // see before
          BYTE      bVolume;                                // default volume
          char      szSmpName[26];                          // sample name (ASCIIZ)
          char      szUnused [ 2];
          DWORD     dwLength;                               // wave length (number of samples)
          DWORD     dwLoopStart;                            // loop start  (number of samples)
          DWORD     dwLoopEnd;                              // loop end    (number of samples)
          DWORD     dwC5Speed;                              // bytes a second for C-5
          DWORD     dwSusStart;                             // sustain loop start
          DWORD     dwSusEnd;                               // sustain loop end
          DWORD     dwOffset;                               // sample  offset in file
          BYTE      bVibSpeed;                              // vibrato speed [0;64]
          BYTE      bVibDepth;                              // vibrato depth [0;64]
          BYTE      bVibType;                               // vibrato waveform type
          BYTE      bVivRate;                               // vibrato rate  [0;64]
} ITSMP_HEADER;                                             // 80 bytes

#pragma   pack()

/************************************************ CLASSES *************************************************************/

/**********************************************************************************************************************/
/*                                                ITSample                                                            */
/**********************************************************************************************************************/

class     CITSample : public CSample
  {
// public methods

  public:

    // constructors & destructor

	  CITSample                           (void);
	 ~CITSample                           (void);

    void            vInit               (void);
    void            vClean              (void);

// protected members

  protected:
  };

/************************************************ INLINE **************************************************************/

/**********************************************************************************************************************/

#endif // !defined(AFX_ITSAMPLE_H__2EE19C60_BC66_11D3_9848_D0068C1C3643__INCLUDED_)
