/**********************************************************************************************************************/
/*                                                INSTRUMENT CLASS                                                    */
/* 03/10/99, M : creation of the file                                                                                 */
/*               1 instrument = 1 or more samples                                                                     */
/**********************************************************************************************************************/

/************************************************ INCLUDE *************************************************************/

#include  "stdafx.h"
#include  "Instrument.h"

#include  "Debug.h"
#include  "Sample.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/**********************************************************************************************************************/
/*                                                CONSTRUCTORS / DESTRUCTOR                                           */
/**********************************************************************************************************************/

//*********************************************** constructors ********************************************************/
// 03/01/99, M
/**********************************************************************************************************************/

CInstrument::CInstrument()
  {
  _DTRCDEF_("CInstrument::CInstrument");
  vInit();
  }

//*********************************************** constructors ********************************************************/
// 08/01/99, M
/**********************************************************************************************************************/

CInstrument::CInstrument(const CSample* lpSample)
  {
  _DTRCDEF_("CInstrument::CInstrument");
  vInit();

  m_lpSample[0] = (CSample*)lpSample;
  }

//*********************************************** destructor **********************************************************/
// 03/10/99, M
/**********************************************************************************************************************/

CInstrument::~CInstrument()
  {
  _DTRCDEF_("CInstrument::~CInstrument");
  vClean();
  }

//*********************************************** vInit ***************************************************************/
// initialize members & resources
// 03/10/99, M
// in :
// out:
/**********************************************************************************************************************/

void CInstrument::vInit()
  {
  _DTRCDEF_("CInstrument::vInit");
  for(DWORD dwI = 0; dwI < _MAX_SAMPLES_; dwI++) m_lpSample[dwI] = NULL;
  }

//*********************************************** vClean **************************************************************/
// release memory & resources
// 03/10/99, M
// in :
// out:
/**********************************************************************************************************************/

void CInstrument::vClean()
  {
  _DTRCDEF_("CInstrument::vClean");
  for(DWORD dwI = 0; dwI < _MAX_SAMPLES_; dwI++) 
    {
    delete m_lpSample[dwI];
    m_lpSample[dwI] = NULL;
    }
  }

/**********************************************************************************************************************/
/*                                                SELECT SAMPLE                                                       */
/**********************************************************************************************************************/

//*********************************************** lpSelectSample ******************************************************/
// return sample address according to given note
// 08/10/99, M
// in : note
// out: sample address
/**********************************************************************************************************************/

CSample* CInstrument::lpSelectSample(const BYTE bNote) const
  {
  _DTRCDEF_("CInstrument::lpSelectSample");
  UNREFERENCED_PARAMETER(bNote);

  return(m_lpSample[0]);
  }
