/**********************************************************************************************************************/
/*                                                MOD CLASS                                                           */
/* 16/11/99, M : creation of the file                                                                                 */
/*               handles a MOD soundtrack                                                                             */
/**********************************************************************************************************************/

#if !defined(AFX_MOD_H__CD73DB21_9C38_11D3_9848_DC686F22DD42__INCLUDED_)
#define AFX_MOD_H__CD73DB21_9C38_11D3_9848_DC686F22DD42__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

#include  "SoundTrack.h"                                    // base class
#include  "MODSample.h"

/************************************************ MACROS **************************************************************/

#define   _SWAP_BYTES_(lpWord)          { WORD wValue = *lpWord; *lpWord = WORD(((wValue & 0xff) << 8) + (wValue >> 8)); }

/************************************************ TYPEDEF & STRUCT ****************************************************/

// MOD file header

#pragma   pack(1)

typedef   struct    {
          char      szMODName [20];                         // song name (ASCII)
          MODSMP_HEADER 
                    smpSample [31];                         // samples info (31*30 bytes)
          BYTE      bSongLength;                            // 1..128
          BYTE      b127;                                   // = 127
          BYTE      bOrderList[128];                        // patterns = 0..63
          char      szMK      [4];                          // "M.K." signature (or "FLT4" or "FLT8")
} MOD_HEADER;                                               // 1084 bytes

#pragma   pack()

/************************************************ CLASSES *************************************************************/

/**********************************************************************************************************************/
/*                                                MOD                                                                 */
/**********************************************************************************************************************/

class     CMOD      : public CSoundTrack
  {
// public methods

  public:

    // constructors & destructor

	  CMOD                                (void);
	 ~CMOD                                (void);

    void            vInit               (void);
    void            vClean              (void);

    // load & inits

    const char*     lpszGetExtension    (void) const;       // return file extension
    HRESULT         hrCheckSignature    (void);             // check the current file is a MOD 
    DWORD           dwModC4Speed        (const BYTE bFineTune);
    HRESULT         hrInitVars          (void);             // init starting values + samples & patterns pointers

    // pattern data

    void            vGoToRow            (BYTE** lplpbPattern,const BYTE bRow);
    void            vUnpackRow          (BYTE*  lpbUnpacked,BYTE** lplpbNote);

    // get

    const char*     lpszGetTitle        (void) const;

// protected members

  protected:

    // song

    DWORD           m_dwPattSize;                           // pattern size in bytes

    // file

    static const char
                    m_szExtension[_MAX_EXT];                // MOD file extension
  };

/************************************************ INLINE **************************************************************/

/**********************************************************************************************************************/

#endif // !defined(AFX_MOD_H__CD73DB21_9C38_11D3_9848_DC686F22DD42__INCLUDED_)
