/**********************************************************************************************************************/
/*                                                MIXER PLAYING PARAMETERS                                            */
/* 03/12/99, M : creation of the file                                                                                 */
/*               allows a soundtrack to be mixed more than once at the same time                                      */
/**********************************************************************************************************************/

#if !defined(AFX_PARAMSMIXER_H__F43CF320_A996_11D3_9848_8E2F4F22F042__INCLUDED_)
#define AFX_PARAMSMIXER_H__F43CF320_A996_11D3_9848_8E2F4F22F042__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

/************************************************ DEFINE **************************************************************/

/************************************************ TYPEDEF & STRUCT ****************************************************/

/************************************************ CLASSES *************************************************************/

class     CParamsSong;

/**********************************************************************************************************************/
/*                                                Params mixer                                                        */
/**********************************************************************************************************************/

class     CParamsMixer
  {
// public methods

  public:

    // constructors & destructor

	  CParamsMixer                        (void);
	 ~CParamsMixer                        (void);       

    void            vInit               (void);
    void            vClean              (void);

// public members

  public:

    // play

    DWORD           m_dwMixSpeed;                           // mixing frequency (in Hz)
    bool            m_boMix16b;                             // mixing output (8b/16b)
    WORD            m_wTimerSpeed;                          // tempo value
    WORD            m_wTimerSpeedRem;                       // tempo value remainder

    WORD            m_wBufLen;                              // bytes to fill in MixBuffer
    WORD            m_wBufPos;                              // curt position in MixBuffer

    // flags

    bool            m_boPlay;                               // is the song being played ?

    // linked list

    CParamsMixer*   m_lpNext;
    CParamsMixer*   m_lpPrev;

    // corresponding song params

    CParamsSong*    m_lpParamsSong;
  };

/************************************************ INLINE **************************************************************/

//#include  "ParamsMixer.inl"

/**********************************************************************************************************************/

#endif // !defined(AFX_PARAMSMIXER_H__F43CF320_A996_11D3_9848_8E2F4F22F042__INCLUDED_)
