/**********************************************************************************************************************/
/*                                                SOUNDTRACK PLAYING PARAMETERS                                       */
/* 01/12/99, M : creation of the file                                                                                 */
/*               allows a soundtrack to be mixed more than once at the same time                                      */
/**********************************************************************************************************************/

#include  "stdafx.h"
#include  "ParamsSong.h"

#include  "Debug.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/**********************************************************************************************************************/
/*                                                CONSTRUCTORS / DESTRUCTOR                                           */
/**********************************************************************************************************************/

/************************************************ constructors ********************************************************/
// 01/12/99, M
/**********************************************************************************************************************/

CParamsSong::CParamsSong()
  {
  _DTRCDEF_("CParamsSong::CParamsSong");
  vInit();
  m_lpNext = NULL;
  m_lpPrev = NULL;
  }

/************************************************ destructor **********************************************************/
// 01/12/99, M
/**********************************************************************************************************************/

CParamsSong::~CParamsSong()
  {
  _DTRCDEF_("CParamsSong::~CParamsSong");
  //vClean();
  }

/************************************************ vInit ***************************************************************/
// initialize members & resources
// 01/12/99, M
// in :
// out:
/**********************************************************************************************************************/

void CParamsSong::vInit()
  {
  _DTRCDEF_("CParamsSong::vInit");
  m_boInitParams    = false;

  m_boStereo        = true;
  m_bGlobalVolume   = 64;
  m_bTempo          = 125;
  m_bPatternSpeed   = 6;

  memset(m_chanInfo,0,sizeof(m_chanInfo));

  m_bPatternRow     = 64;
  m_bPlayingPattern = 0;
  m_bPatternCount   = 1;
  m_bBreakData      = 0;
  m_bSynchro        = 0;
  m_boRepeat        = true;
  m_boPlaying       = false;

  m_fRunningTime    = 0.f;
  m_dwHandle        = 0;
  }

/************************************************ vClean **************************************************************/
// release memory & resources
// 01/12/99, M
// in :
// out:
/**********************************************************************************************************************/

void CParamsSong::vClean()
  {
  _DTRCDEF_("CParamsSong::vClean");
  vInit();
  }
