/**********************************************************************************************************************/
/*                                                SMP CLASS                                                           */
/* 03/10/99, M : creation of the file                                                                                 */
/*               handles an SMP sample (S3M format)                                                                   */
/**********************************************************************************************************************/

#if !defined(AFX_SMP_H__4C0D8F39_79A8_11D3_9848_FD35403E9742__INCLUDED_)
#define AFX_SMP_H__4C0D8F39_79A8_11D3_9848_FD35403E9742__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

#include  "Sample.h"                                        // base class

/************************************************ DEFINE **************************************************************/

#define   _SMPFLAG_SMPTYPE_             1                   // sample
#define   _SMPFLAG_LOOP_                1                   // use loop
#define   _SMPFLAG_STEREO_              2                   // stereo sample
#define   _SMPFLAG_16BITS_              4                   // 16b/8b sample

/************************************************ TYPEDEF & STRUCT ****************************************************/

// SMP header

#pragma   pack(1)

typedef   struct    {
          BYTE      bSmpType;                               // 1=sample
          char      szSmpName[12];                          // sample name (ASCIIZ)
          BYTE      bMemSeg;
          WORD      wMemSeg;                                // wave offset/16
          DWORD     dwLength;                               // wave length
          DWORD     dwLoopStart;                            // loop start
          DWORD     dwLoopEnd;                              // loop end
          BYTE      bVolume;                                // default volume
          char      szUnused1[ 2];                          // xx-00
          BYTE      bFlags;                                 // +1=loop, +2=stereo, +4=16b
          DWORD     dwC4Speed;                              // C4 frequency
          char      szUnused2[12];
          char      szComment[28];                          // text
          char      szSCRS   [ 4];                          // "SCRS" signature
} SMP_HEADER;                                               // 80 bytes

#pragma   pack()

/************************************************ CLASSES *************************************************************/

/**********************************************************************************************************************/
/*                                                SMP                                                                 */
/**********************************************************************************************************************/

class     CSMP      : public CSample
  {
// public methods

  public:

    // constructors & destructor

	  CSMP                                (void);
	 ~CSMP                                (void);

    void            vInit               (void);
    void            vClean              (void);

// protected members

  protected:
  };

/************************************************ INLINE **************************************************************/

/**********************************************************************************************************************/

#endif // !defined(AFX_SMP_H__4C0D8F39_79A8_11D3_9848_FD35403E9742__INCLUDED_)
