/**********************************************************************************************************************/
/*                                                SAMPLE CLASS                                                        */
/* 03/10/99, M : creation of the file                                                                                 */
/*               handles a generic sample (raw format)                                                                */
/* 07/01/00, M : ping-pong loop                                                                                       */
/**********************************************************************************************************************/

#if !defined(AFX_SAMPLE_H__4C0D8F38_79A8_11D3_9848_FD35403E9742__INCLUDED_)
#define AFX_SAMPLE_H__4C0D8F38_79A8_11D3_9848_FD35403E9742__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif

/************************************************ INCLUDE *************************************************************/

/************************************************ DEFINE **************************************************************/

/************************************************ TYPEDEF & STRUCT ****************************************************/

/************************************************ CLASSES *************************************************************/

/**********************************************************************************************************************/
/*                                                Sample                                                              */
/**********************************************************************************************************************/

class     CSample
  {
// public methods

  public:

    // constructors & destructor

	  CSample                             (void);
	  virtual        ~CSample             (void);

    void            vInit               (void);
    void            vClean              (void);

    // get

    void*           lpvGetHeader        (void) const;
    BYTE*           lpbGetDataRAM       (void) const;
    DWORD           dwGetC4Speed        (void) const;

    DWORD           dwGetLength         (void) const;
    DWORD           dwGetRepeat         (void) const;
    DWORD           dwGetRepLen         (void) const;

    bool            boGet16Bits         (void) const;
    BYTE            bGetVolume          (void) const;
    bool            boGetPingPong       (void) const;

    // set

    void            vSetHeader          (const void* lpvHeader);
    void            vSetDataRAM         (const BYTE* lpbData);
    void            vSetC4Speed         (const DWORD dwSpeed);

    void            vSetLength          (const DWORD dwLength);
    void            vSetRepeat          (const DWORD dwRepeat);
    void            vSetRepLen          (const DWORD dwRepLen);

    void            vSet16Bits          (const bool  bo16Bits);
    void            vSetVolume          (const BYTE  bVolume);
    void            vSetPingPong        (const bool  boPingPong);

// protected members

  protected:

    void*           m_lpvHeader;                            // header   address
    BYTE*           m_lpbDataRAM;                           // data RAM address
    DWORD           m_dwC4Speed;                            // C4 speed

    DWORD           m_dwLength;                             // data length
    DWORD           m_dwRepeat;                             // loop start
    DWORD           m_dwRepLen;                             // loop length

    bool            m_bo16Bits;                             // 8b/16b flag
    BYTE            m_bVolume;                              // default volume
    bool            m_boPingPong;                           // ping-pong loop ?
  };

/************************************************ INLINE **************************************************************/

//#include  "Sample.inl"

/**********************************************************************************************************************/

#endif // !defined(AFX_SAMPLE_H__4C0D8F38_79A8_11D3_9848_FD35403E9742__INCLUDED_)
