/**********************************************************************************************************************/
/*                                                SAMPLE CLASS                                                        */
/* 03/10/99, M : creation of the file                                                                                 */
/*               handles a generic sample (raw format)                                                                */
/* 07/01/00, M : ping-pong loop                                                                                       */
/**********************************************************************************************************************/

#ifndef   _SAMPLE_INL_
#define   _SAMPLE_INL_

/************************************************ INCLUDE *************************************************************/

#include  "Sample.h"

/**********************************************************************************************************************/
/*                                                GET                                                                 */
/**********************************************************************************************************************/

inline void* CSample::lpvGetHeader () const
  {
  return m_lpvHeader;
  }

inline BYTE* CSample::lpbGetDataRAM() const
  {
  return m_lpbDataRAM;
  }

inline DWORD CSample::dwGetC4Speed () const
  {
  return m_dwC4Speed;
  }

inline DWORD CSample::dwGetLength  () const
  {
  return m_dwLength;
  }

inline DWORD CSample::dwGetRepeat  () const
  {
  return m_dwRepeat;
  }

inline DWORD CSample::dwGetRepLen  () const
  {
  return m_dwRepLen;
  }

inline bool  CSample::boGet16Bits  () const
  {
  return m_bo16Bits;
  }

inline BYTE  CSample::bGetVolume   () const
  {
  return m_bVolume;
  }

inline bool  CSample::boGetPingPong() const
  {
  return m_boPingPong;
  }

/**********************************************************************************************************************/
/*                                                SET                                                                 */
/**********************************************************************************************************************/

inline void CSample::vSetHeader  (const void* lpvHeader)
  {
  m_lpvHeader = (void*)lpvHeader;
  }

inline void CSample::vSetDataRAM (const BYTE* lpbData)
  {
  m_lpbDataRAM = (BYTE*)lpbData;
  }

inline void CSample::vSetC4Speed (const DWORD dwSpeed)
  {
  m_dwC4Speed = dwSpeed;
  }

inline void CSample::vSetLength  (const DWORD dwLength)
  {
  m_dwLength = dwLength;
  }

inline void CSample::vSetRepeat  (const DWORD dwRepeat)
  {
  m_dwRepeat = dwRepeat;
  }

inline void CSample::vSetRepLen  (const DWORD dwRepLen)
  {
  m_dwRepLen = dwRepLen;
  }

inline void CSample::vSet16Bits  (const bool  bo16Bits)
  {
  m_bo16Bits = bo16Bits;
  }

inline void CSample::vSetVolume  (const BYTE  bVolume)
  {
  m_bVolume = bVolume;
  if(m_bVolume > 63) m_bVolume = 63;
  }

inline void CSample::vSetPingPong(const bool boPingPong)
  {
  m_boPingPong = boPingPong;
  }

/**********************************************************************************************************************/

#endif
